#!/bin/bash
# $Revision: 1.4 $
# STANDARD 1.0
# PLUGIN TYPE:LIST
# PLUGIN LIST:irc.italian-amici.org #hailander

######################################################################
echo "BEGIN: $(basename $0) $*" >&2
######################################################################
# Questo e' un "bash script plugin" per BuDuScRiPt/budus_xdcc.sh

# Il suo scopo e' quello di fornire un "motore di ricerca".

######################################################################
function make_data_file_exchange() {
    search_result=$(cat /tmp/budus_XDCC_db_${plugin_name}.${date_code})
    for pattern in ${SEARCH_STRING}; do
	search_result=$(echo "${search_result}" | grep -iF "${pattern}")
    done
    
    echo "${search_result}" > ${plugin_tempfile}.database
}

######################################################################
# Lo script "budus_xdcc.sh" invoca questo script passando, come primo
# parametro, un codice casuale che serve per calcolare il file dentro
# al quale immagazzinare il risultato opportunamente filtrato.
RANDOM_NUMBER=${1}

# Il secondo parametro e' il numero di secondi d'attesa del risultato
# dal sito web interrogato, trascorsi i quali, si deve interrompere la
# ricerca del plugin.
WGET_TIMEOUT=${2}

# Il terzo parametro rappresenta la "stringa di ricerca" immessa
# dall'utente.
SEARCH_STRING=${3}

######################################################################
# VARIABILI AD USO DEL FILTRO
######################################################################
db_url="http://www.italian-amici.net/hailander/"
wget_option="-q -t 1 -O - -T ${WGET_TIMEOUT}"
date_code=$(date +%Y%m%d)

######################################################################
# Viene calcolato il nome del file dati dentro al quale immagazzinare
# il risultato.
plugin_name=$(echo "${0}" | sed 's@.*budus_xdcc_plugin_@@' | cut -f1 -d'.')
user_home=$(echo "${HOME}" | tr [:punct:] '_')
plugin_tempfile=/tmp/budus_XDCC_${plugin_name}_${user_home}_${RANDOM_NUMBER}

######################################################################
# Questo plugin, scaricando una lista anziche' interrogando un motore
# di ricerca web, lavore in modo diverso: salva il risultato
# "giornaliero" (cioe' lo aggiorna solo una volta al giorno)
if [ -f /tmp/budus_XDCC_db_${plugin_name}.${date_code} ]; then
    make_data_file_exchange

    rm -f ${plugin_tempfile}    
    echo "END  : $(basename $0) $*" >&2
    exit 0;
else
    rm -f /tmp/budus_XDCC_db_${plugin_name}.*
fi

######################################################################
wget ${wget_option} ${db_url}   | sed 's/\r//g'  > ${plugin_tempfile}
cp -f ${plugin_tempfile} /tmp/budus_XDCC_db_${plugin_name}.dat

######################################################################
if [ ! -f "${plugin_tempfile}" ]; then
    echo > "${plugin_tempfile}"
    if [ ! -f "${plugin_tempfile}" ]; then
	echo "/ECHO %C4,1Non sono in grado di creare files temporanei in /tmp, problema di permessi ?"
	echo "/ECHO (${plugin_tempfile})"
	exit 1;
    else
	echo "/ECHO %C4,1Il plugin non e' stato in grado di generare il database. Segnalare il problema a UDA'Software, se persiste."
	exit 1;
    fi
fi

######################################################################
# Filtraggio
# L'output del filtro e' rappresentato da 8 campi separati dal
# carattere di tabulazione '\t', ovvero:
# NETWORK_NAME NETWORK_HOST CHANNEL BOT_NAME ID FILE_NAME SIZE COMMAND
#       1            2         3        4    5      6      7      8
######################################################################
cat ${plugin_tempfile} \
    | grep -F ' OnClick="t(' \
    | sed 's@.* OnClick="t(.@\nItalian-Amici\tirc.italian-amici.org\t#hailander\t@g' \
    | sed "s@','#@\t#@g" \
    | sed "s@');.href=#.* width=[0-9]*%>@\t@g" \
    | sed 's@<td width=[0-9]*% align=left>@\t@g' \
    | sed 's@</td></tr>$@@g' \
    | sed 's@<font color=#[0-9A-F]\{6\}> @@g' \
    | sed 's@ \?</font> \?@@g' \
    | sed 's@</td>.*$@@g' \
    | sed 's@[0-9]\{4\}.[0-9]\{2\}.[0-9]\{2\} [0-9]\{2\}:[0-9]\{2\} @@' \
    | grep -v ^$ \
    | awk -F'\t' '{print $1"\t"$2"\t"$3"\t"$4"\t"$5"\t"$7"\t"$6"\t/msg "$4" xdcc send "$5}' \
    > /tmp/budus_XDCC_db_${plugin_name}.${date_code}

make_data_file_exchange

######################################################################
rm -f ${plugin_tempfile}

######################################################################
echo "END  : $(basename $0) $*" >&2
######################################################################